<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class CommentController extends Controller
{    
    function saveCommentAction($siteId)
    {
        $site = $this->site->findByPk($siteId);
        if(empty($site))$this->return404();
        
        $this->viewClass = "JsonView";
        
        //check can vote
        $errorMessage = $this->comment->checkCanVote($siteId, $this->request->getIp());
        
        //check Captcha if enabled
        if(!$errorMessage && Config::get('captchaEnabledOnComments')
           && !$this->captchaCode->validatePublicAndPrivateCodes($this->request))
           $errorMessage = 'You did not guess the error correcting code, please try again.';
        
        //if captcha is okey save comment
        if($errorMessage)
        {
            $this->set("status", "error");
            $this->set("message", $errorMessage);
            return;
        }
        
        $this->comment->setSiteCookie($siteId);
                      
        // insert comment
        $comment = new CommentRecord();
        $comment->remoteIp = $this->request->getIp();
        $comment->siteId = $siteId;
        $comment->text = $this->request->text; 
        $comment->pseudo  = $this->request->pseudo;
        $comment->validated = Config::get("automaticCommentValidation") ? "1" : "0";
        $comment->save();
        
        $this->set("status", "ok");
        $this->set("message", "You have successfully post comment");
        
        $redirectUrl = (Config::get("commentsDisplayMethod") == "popup") ? $this->moduleLink("popup/".$site->siteId) : FrontController::getRewrittedUrl("/site/details/".$site->siteId."/".str_replace("/", " ", $site->siteTitle));
        $this->set("redirectUrl", $redirectUrl);  
    }
    
    function popupAction($siteId)
    {
        //if comments aren't enabled return 404
        if(!Config::get("commentsEnabled"))return $this->return404();
    
        $this->set("siteId", $siteId);

        //check can vote
        $errorMessage = $this->comment->checkCanVote($siteId, $this->request->getIp());
        
        //get all comment for this site
        $this->set("comments", $this->comment->getSiteValidatedComments($siteId));
        $this->set("displayForm", empty($errorMessage));
    }
}

?>
