<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class ContactController extends Controller
{
    /**
    * Validate captcha code if enabled
    */
    private function validate()
    {
        if(Config::get('captchaEnabledOnContactForm') 
            && !$this->captchaCode->validatePublicAndPrivateCodes($this->request))
            return _t('You did not guess the security code.');
        
        return false;
    }
    
    /**
    * Display contact form 
    */
    function indexAction()
    {
        if(!isset($this->request->email))return;

        $errorMessage = $this->validate();
        $message = '';
           
        if(!$errorMessage)        
        {
            //captcha disabled or captcha code match
            $mailer = Mailer::getInstance(); 
            if($mailer->sendEmailToAdmin($this->request->subject,
                                         $this->request->message,
                                         $this->request->email))
                                         {
                                             $message = _t('Your message was sent.'); 
                                         }
                                         else
                                         {
                                             $message = _t('Your message was not sent. Sorry for the inconvenience.'); 
                                         }
        }
        else
        {
            $message = $errorMessage;
        }
        
        $this->set("message", $message);

    }
}

?>