<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class MainController extends Controller
{
    /**
    * Index page
    */
    function indexAction()
    {             
        //set adPage
        Display::set("adPage", "index");
        
        //set META description
        $this->set("metaDescription", Config::get("siteDescription"));
        
        $cache = Cacher::getInstance();
        
        //retrieve predefinied html directoryDescription from db
        if(($message = $cache->load("directoryDescription")) === null)
        {
            $message = $this->customMessage->findByPk("directoryDescription");
            $cache->save($message, null, null, array("custommessage"));
        }
        
        $this->set("directoryDescription", $message);
    }
    
    function saveReferrerAction()
    {
        $refererUrl = Request::getInstance()->getRefererUrl();
        
        if($refererUrl
           && FrontController::getHostNameFromUrl($refererUrl)
           != FrontController::getHostNameFromUrl(Config::get('siteRootUrl')))
        {
             Model::factoryInstance("otherReferrerSite")->saveReferrer($refererUrl);
             Model::factoryInstance("searchTag")->handleSearchEngineReferrer($refererUrl);
        }
        
        $this->autoRender = false;
    }
} 

?>
