<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class NewsletterController extends Controller
{
    function setEmailAction()
    {
        if(!Config::get("newsletterEnabled"))$this->return404(); 
        
        if(!empty($this->request->addEmail))
        {
            $newsletterEmail = $this->newsletterEmail->addEmail($this->request->email);
            
            if($newsletterEmail)
            {
                $verification = $this->verification->addVerification($newsletterEmail->emailId, "newsletterEmailAdd");
                $confirmLink = Config::get("siteRootUrl").$this->moduleLink("confirmNewsletterEmailAdd/".$verification->code, false);
                Mailer::getInstance()->sendEmailConfirmation("newsletterEmailAdd", $this->request->email, $confirmLink);
            }
        }
            
        if(!empty($this->request->deleteEmail))
        {
            $c = new Criteria();
            $c->add("email", $this->request->email);
            $newsletterEmail = $this->newsletterEmail->find($c);
            
            if(!empty($newsletterEmail))
            {
                $verification = $this->verification->addVerification(null, "newsletterEmailDel", $newsletterEmail->email);
                $confirmLink = Config::get("siteRootUrl").$this->moduleLink("confirmNewsletterEmailDel/".$verification->code, false);
                Mailer::getInstance()->sendEmailConfirmation("newsletterEmailDel", $this->request->email, $confirmLink);
            }
        }
            
        $this->redirect(Config::get("siteRootUrl"));
    }
    
    function confirmNewsletterEmailAddAction($confirmCode)
    {
        if(!Config::get("newsletterEnabled"))$this->return404();
        
        $verification = $this->verification->findByCodeType($confirmCode, "newsletterEmailAdd");
        
        if(!empty($verification))
        {
            $newsletterEmail = $this->newsletterEmail->findByPk($verification->itemId);
                
            if(!empty($newsletterEmail))
            {
                $newsletterEmail->active = 1;
                $newsletterEmail->save();
            }
            
            $verification->del();
        }  
    }
    
    function confirmNewsletterEmailDelAction($confirmCode)
    {
        $verification = $this->verification->findByCodeType($confirmCode, "newsletterEmailDel");
        
        if(!empty($verification))
        {
            $email = $verification->data;
            
            $c = new Criteria();
            $c->add("email", $email);
            $newsletterEmail = $this->newsletterEmail->find($c);
                
            if(!empty($newsletterEmail))
            {
                $newsletterEmail->del();
            }
                
            $c = new Criteria();
            $c->add("webmasterEmail", $email);
            $this->site->update(array("newsletterActive" => "0"), $c);
            $verification->del();
        }
    }
}

?>