<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////
 
/**
 * Class for storing values with arrayAccess and IteratorAggregate 
 */
class DataAggregator extends Object implements ArrayAccess, IteratorAggregate  
{
    protected $data;
   
    public function __construct($data = array())
    {
        $this->data = $data;
    }
                
    public function __get($name)
    {                            
        return $this->data[$name];
    }
   
    public function __set($name, $value)
    {
        $this->data[$name] = $value; 
    }
    
    public function __isset($name)
    {
        return isset($this->data[$name]);    
    }
   
    public function getIterator()
    {
        return new ArrayObject($this->data);
    }
    
    public function offsetExists($offset)
    {
        return isset($this->data[$offset]);
    }
    
    public function offsetGet($offset)
    {
        return $this->data[$offset];
    }
    
    public function offsetSet($offset, $value)
    {
        $this->__set($offset, $value); 
    }
    
    public function offsetUnset($offset)
    {
        unset($this->data[$offset]);
    }    
    
    public function toArray()
    {
        return $this->data;
    }
    
    public function fromArray($data)
    {
        $this->data = $data;
        return $this;
    }
}

?>